unit ChartTestMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, TeEngine, Series, TeeProcs, Chart;

type
  TForm1 = class(TForm)
    chrtStrip: TChart;
    serStrip: TLineSeries;
    btnStart: TButton;
    Timer1: TTimer;
    btnStop: TButton;
    procedure btnStartClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
  private
    { Private declarations }
    iChartPointCount : Integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  iuSTRIPPOINTS = 480;


procedure TForm1.btnStartClick(Sender: TObject);
  const
    fInHere : Boolean = False;
  var
    i : Integer;
  begin
  btnStart.Enabled := False;
  btnStop.Enabled  := True;

  // Fill the chart up (with invisible points :-)
  if Assigned(serStrip.ParentChart) then
    begin
    serStrip.ParentChart.AutoRepaint := False;
    end;
  try
    serStrip.Clear;
    for i := 0 to PRED(iuSTRIPPOINTS) do
      begin
      serStrip.AddNullXY(i, 0,'');
      end;
  finally
  if Assigned(serStrip.ParentChart) then
    begin
    serStrip.ParentChart.AutoRepaint := True;                      // Be sure painting is enabled
    if not serStrip.ParentChart.Zoom.Active then
      begin
      serStrip.ParentChart.Invalidate;
      PostMessage(serStrip.ParentChart.Handle, WM_PAINT, 0, 0);
      end;
    end;
  end;

  iChartPointCount := 0;
  Timer1.Enabled := True;
  end;

procedure TForm1.btnStopClick(Sender: TObject);
  begin
  Timer1.Enabled := False;
  btnStart.Enabled := True;
  btnStop.Enabled  := False;
  end;

procedure TForm1.Timer1Timer(Sender: TObject);
  begin
    if Assigned(serStrip.ParentChart) then
      begin
      serStrip.ParentChart.AutoRepaint := False;
      end;
    serStrip.YValue[iChartPointCount] := Random(200);
    serStrip.ValueColor[iChartPointCount] := serStrip.SeriesColor;
    if Assigned(serStrip.ParentChart) then
      begin
      serStrip.ParentChart.AutoRepaint := True;
      end;
    if not serStrip.ParentChart.Zoom.Active then
      begin
      serStrip.ParentChart.Invalidate;
      PostMessage(serStrip.ParentChart.Handle, WM_PAINT, 0, 0);
      end;
    INC(iChartPointCount);
    if iChartPointCount = iuSTRIPPOINTS then
      begin
      Timer1.Enabled := False;
      end;
  end;

end.
